//+------------------------------------------------------------------+
//|                                                    FibLevels.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#define HIGH 345
#define LOW 3455

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Silver
#property indicator_color2 Gold
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_color6 Silver
#property indicator_color7 Gold
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,159);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,159);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   double get[]={0,-61.8,38.2,50,61.8,100,161.8};
   double fibs[];
   for(int i=0;i<Bars-counted_bars;i++){
      datetime time=Time[i];
      getFibs(get,fibs,time);
      ExtMapBuffer1[i]=fibs[0];
      ExtMapBuffer2[i]=fibs[1];
      ExtMapBuffer3[i]=fibs[2];
      ExtMapBuffer4[i]=fibs[3];
      ExtMapBuffer5[i]=fibs[4];
      ExtMapBuffer6[i]=fibs[5];
      ExtMapBuffer7[i]=fibs[6];
      
   }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+


int getFibs(double use[],double& set[],datetime time){
   int mode;int c;
   if(TimeDayOfWeek(time)==1)int s=iBarShift(Symbol(),1440,time-(60*60*24*3));
   else s=iBarShift(Symbol(),1440,time-(60*60*24));
   double range=iHigh(Symbol(),1440,s)-iLow(Symbol(),1440,s);
   if(iClose(Symbol(),1440,s) < iOpen(Symbol(),1440,s) ){
      double startprice=iLow(Symbol(),1440,s);
      mode=LOW;
   }else{
      startprice=iHigh(Symbol(),1440,s);
      mode=HIGH;
   }
   for(int i=0;i<ArraySize(use);i++){
      ArrayResize(set,i+1);
      if(mode==LOW){
         set[i]=NormalizeDouble(startprice+(range*(use[i]/100)),Digits);
      }
      else if (mode==HIGH){
         set[i]=NormalizeDouble(startprice-(range*(use[i]/100)),Digits);
      }
      c++;
   }
   if(c<=0)return(-1);
   return(mode);
}